/*
 * $Id: boot.d,v 1.2 2006/11/23 02:29:43 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.ttn;

import java.awt.Container;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;

import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLEventListener;

import com.sun.opengl.util.Animator;
import com.sun.opengl.util.FPSAnimator;

import abagames.util.Logger;
import abagames.util.Tokenizer;
import abagames.util.sdl.*;
import abagames.util.sdl.Pad.RecordablePad;

/*private import std.string;
private import std.stream;
private import std.math;
private import std.c.stdlib;
private import abagames.util.logger;
private import abagames.util.tokenizer;
private import abagames.util.sdl.mainloop;
private import abagames.util.sdl.input;
private import abagames.util.sdl.pad;
private import abagames.util.sdl.recordableinput;
private import abagames.util.sdl.sound;
private import abagames.ttn.screen;
private import abagames.ttn.frame;
private import abagames.ttn.preference;
private import abagames.ttn.enemy;*/

/**
 * Boot the game.
 */
public class Boot implements GLEventListener, KeyListener {
	private Screen screen;
	private RecordablePad input;
	private Frame frame;
	private Preference preference;
	private MainLoop mainLoop;
	
	Animator animator;

//	version (Win32_release) {
//   Boot as the Windows executable.
//  private import std.c.windows.windows;
//  private import std.string;

//  extern (C) void gc_init();
//  extern (C) void gc_term();
//  extern (C) void _minit();
//  extern (C) void _moduleCtor();

//	// Boot as the general executable.
//	public static void main(String[] args) {
//		Boot b = new Boot();
//		b.boot(args);
//	}
//
//	public int boot(String[] args) {
//		GL gl = null;//TODO
//		screen = new Screen();
//		input = new RecordablePad();
//		frame = new Frame();
//		preference = new Preference();
//		mainLoop = new MainLoop(screen, input, frame, preference);
//		try {
//			parseArgs(args, screen, input, mainLoop);
//		} catch (Exception e) {
//			return 1;//EXIT_FAILURE;
//		}
//		mainLoop.loop(gl);
//		return 0;//EXIT_SUCCESS;
//	}

	public int startApplet(Container c, String[] args) {
		screen = new Screen();
		c.add(screen);
		input = new RecordablePad();
		frame = new Frame();
		preference = new Preference();
		mainLoop = new MainLoop(screen, input, frame, preference);
		try {
			parseArgs(args, screen, input, mainLoop);
		} catch (Exception e) {
			return 1;//EXIT_FAILURE;
		}
//		mainLoop.loop(gl);
		screen.addGLEventListener(this);
		screen.addKeyListener(this);
		screen.setSize(c.getSize());
		animator = new FPSAnimator((GLCanvas)screen, 60);
		animator.start();
		return 0;//EXIT_SUCCESS;
	}
	
	public void stopApplet() {
		if (animator != null)
			animator.stop();
	}

	private void parseArgs(String[] commandArgs, Screen screen, RecordablePad pad, MainLoop mainLoop) {
//		char[][] args = readOptionsIniFile();
//		for (int i = 1; i < commandArgs.length; i++)
//			args ~= commandArgs[i];
//		char[] progName = commandArgs[0];
//		for (int i = 0; i < args.length; i++) {
//			switch (args[i]) {
//			case "-fullscreen":
//				screen.windowMode = false;
//				break;
//			case "-window":
//				screen.windowMode = true;
//				break;
//			case "-res":
//				if (i >= args.length - 2) {
//					usage(progName);
//					throw new Exception("Invalid options");
//				}
//				i++;
//				int w = std.string.atoi(args[i]);
//				i++;
//				int h = std.string.atoi(args[i]);
//				screen.width = w;
//				screen.height = h;
//				break;
//			case "-brightness":
//				if (i >= args.length - 1) {
//					usage(progName);
//					throw new Exception("Invalid options");
//				}
//				i++;
//				float b = cast(float) std.string.atoi(args[i]) / 100;
//				if (b < 0 || b > 1) {
//					usage(args[0]);
//					throw new Exception("Invalid options");
//				}
//				Screen.brightness = b;
//				break;
//			case "-nosound":
//				Sound.noSound = true;
//				break;
//			case "-exchange":
//				pad.buttonsExchanged = true;
//				break;
//			case "-trail":
//				EnemyPool.trailEffect = true;
//				break;
//			case "-noslowdown":
//				mainLoop.noSlowdown = true;
//				break;
//			default:
//				usage(progName);
//			throw new Exception("Invalid options");
//			}
//		}
	}
	
	private static final String OPTIONS_INI_FILE = "options.ini";
	
	private ArrayList<String> readOptionsIniFile() {
		try {
			return Tokenizer.readFile(OPTIONS_INI_FILE, " ");
		} catch (Exception e) {
			return null;
		}
	}
	
	private void usage(String progName) {
		Logger.error
		("Usage: " + progName + " [-fullscreen] [-res x y] [-brightness [0-100]] [-nosound] [-exchange] [-trail] [-noslowdown]");
	}

	public void display(GLAutoDrawable drawable) {
//		long t0 = System.nanoTime();
		mainLoop.step(drawable.getGL());
//		long t1 = System.nanoTime();
//		System.out.println((t1 - t0) / 1000000.0);
	}

	public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
		//TODO
	}

	public void init(GLAutoDrawable drawable) {
		mainLoop.init(drawable.getGL());
	}

	public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
		//TODO
		
	}

	public void keyPressed(KeyEvent ev) {
		input.handleEvent(ev);
	}

	public void keyReleased(KeyEvent ev) {
		input.handleEvent(ev);
	}

	public void keyTyped(KeyEvent arg0) {
	}
}