/*
 * $Id: screen.d,v 1.1.1.1 2006/11/19 07:54:55 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.ttn;

import javax.media.opengl.GL;

import abagames.util.sdl.Screen3D;

/**
 * OpenGL screen.
 */
public class Screen extends Screen3D {
	static final String CAPTION = "Titanion";
	static final String ICON_FILE_NAME = "images/ttn_icon32.bmp";
	Field field;
//	GL gl;
	
	protected void setIcon() {
//		SDL_WM_SetIcon(SDL_LoadBMP(ICON_FILE_NAME), null);
	}

	protected void init(GL gl) {
//		this.gl = gl;
		setCaption(CAPTION);
		gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE);
		gl.glEnable(GL.GL_BLEND);
		gl.glEnable(GL.GL_LINE_SMOOTH);
		gl.glDisable(GL.GL_TEXTURE_2D);
		gl.glDisable(GL.GL_COLOR_MATERIAL);
		gl.glDisable(GL.GL_LIGHTING);
		gl.glDisable(GL.GL_DEPTH_TEST);
		gl.glDisable(GL.GL_CULL_FACE);
		setClearColor(gl, 0, 0, 0, 1);
	}

	public void setField(Field field) {
		this.field = field;
		screenResized();
	}

	protected void close() {}

	public void screenResized() {
		super.screenResized();
		GL gl = getGL();
		float lw = ((float) width() / 640 + (float) height() / 480) / 2;
		if (lw < 1)
			lw = 1;
		else if (lw > 4)
			lw = 4;
		gl.glLineWidth(lw);
		gl.glViewport(0, 0, width(), height());
		if (field != null)
			field.setLookAt(gl);
	}
}
