/*
 * $Id: sound.d,v 1.1.1.1 2006/11/19 07:54:55 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.ttn;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;

import abagames.util.Logger;
import abagames.util.Rand;
import abagames.util.sdl.Music;

//private import std.path;
//private import std.file;
//private import abagames.util.rand;
//private import abagames.util.logger;
//private import abagames.util.sdl.sound;

/**
 * Manage BGMs and SEs.
 */
public class Sound extends abagames.util.sdl.Sound {
	public static Rand rand = new Rand();
//	mixin StaticRandImpl;
	private static String[] seFileName =
	{"shot.wav", "explosion1.wav", "explosion2.wav", "explosion3.wav",
		"tractor.wav", "flying_down.wav", "player_explosion.wav", "flick.wav", "extend.wav"};
	static int[] seChannel =
	{0, 1, 2, 3, 4, 5, 6, 6, 7};
	static HashMap<String, Music> bgm = new HashMap<String, Music>();
	static HashMap<String, Chunk> se = new HashMap<String, Chunk>();
	static HashMap<String, Boolean> seMark = new HashMap<String, Boolean>();
	static ArrayList<String> bgmFileName = new ArrayList<String>();
	static String currentBgm;
	static int prevBgmIdx;
	static int nextIdxMv;
	static boolean _bgmEnabled = true;
	static boolean _seEnabled = true;

	public static void load() {
		loadMusics();
		loadChunks();
	}

	private static void loadMusics() {
//		HashMap<String, Music> musics;
//		char[][] files = listdir(Music.dir);
		String[] files = {
				"ttn1.au",
				"ttn2.au",
				"ttn3.au",
		};
		for (String fileName: files) {
			String ext = "au";//getExt(fileName);
//			if (ext.equals("ogg") && ext.equals("wav"))
//				continue;
			Music music = new Music();
			music.load(fileName);
			bgm.put(fileName, music);
			bgmFileName.add(fileName);
			Logger.info("Load bgm: " + fileName);
		}
	}

	private static void loadChunks() {
		int i = 0;
		for (String fileName: seFileName) {
			Chunk chunk = new Chunk();
			chunk.load(fileName, seChannel[i]);
			se.put(fileName, chunk);
			seMark.put(fileName, false);
			Logger.info("Load SE: " + fileName);
			i++;
		}
	}

	public static void playBgm(String name) {
		currentBgm = name;
		if (!_bgmEnabled)
			return;
		Music.halt();
		bgm.get(name).play();
	}

	public static void playBgm() {
		int bgmIdx = rand.nextInt(bgm.size());
		nextIdxMv = rand.nextInt(2) * 2 - 1;
		prevBgmIdx = bgmIdx;
		playBgm(bgmFileName.get(bgmIdx));
	}

	public static void nextBgm() {
		int bgmIdx = prevBgmIdx + nextIdxMv;
		if (bgmIdx < 0)
			bgmIdx = bgm.size() - 1;
		else if (bgmIdx >= bgm.size())
			bgmIdx = 0;
		prevBgmIdx = bgmIdx;
		playBgm(bgmFileName.get(bgmIdx));
	}

	public static void playCurrentBgm() {
		playBgm(currentBgm);
	}

	public static void fadeBgm() {
		Music.fade();
	}

	public static void haltBgm() {
		Music.halt();
	}

	public static void playSe(String name) {
		if (!_seEnabled)
			return;
		seMark.put(name, true);
	}

	public static void playMarkedSes() {
		Set<String> keys = seMark.keySet();
		for (String key: keys) {
			if (seMark.get(key)) {
				se.get(key).play();
				seMark.put(key, false);
		}
		}
	}

	public static void clearMarkedSes() {
		Set<String> keys = seMark.keySet();
		for (String key: keys)
			seMark.put(key, false);
	}

	public static void bgmEnabled(boolean v) {
		_bgmEnabled = v;
	}

	public static void seEnabled(boolean v) {
		_seEnabled = v;
	}
}
