/*
 * Created on 2006/11/25
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package abagames.util;

import javax.media.opengl.GL;


/**
 * Object pool for actors.
 */
public class ActorPool <T extends Actor>{
	public static interface ActorCreator<T> {
		public T create();
		public T[] createArray(int n);
	}
	
	public T[] actors;
	protected int actorIdx = 0;
	private boolean hasNoActor;
	private ActorCreator<T> creator;
	
	public ActorPool(ActorCreator<T> c) {
		creator = c;
	}
	
	/*public void init(int n, Object[] args = null) {
	 createActors(n, args);
	 }*/
	
	public void init(int n, Object[] args) {
		//			for (int i = 0; i < _arguments.length; i++)
		//				args ~= va_arg!(Object)(_argptr);
		createActors(n, args);
	}
	
	@SuppressWarnings("unchecked")
	protected void createActors(int n, Object[] args) {
		actors = (T[])creator.createArray(n);
		for (int i = 0; i < n; i++) {
			actors[i] = creator.create();
			actors[i].exists(false);
			actors[i].init(args);
		}
		actorIdx = 0;
		hasNoActor = false;
	}
	
	public T getInstance() {
		if (hasNoActor)
			return null;
		for (int i = 0; i < actors.length; i++) {
			actorIdx--;
			if (actorIdx < 0)
				actorIdx = actors.length - 1;
			if (!actors[actorIdx].exists()) 
				return actors[actorIdx];
		}
		hasNoActor = true;
		return null;
	}
	
	public T getInstanceForced() {
		actorIdx--;
		if (actorIdx < 0)
			actorIdx = actors.length - 1;
		return actors[actorIdx];
	}
	
	@SuppressWarnings("unchecked")
	public T[] getMultipleInstances(int n) {
		if (hasNoActor)
			return null;
		T[] rsl = (T[])new Actor[n];
		for (int i = 0; i < n; i++) {
			T inst = getInstance();
			if (inst == null) {
				for (int j = 0; j < i; j++)// FIXME
					rsl[j].exists(false);
				return null;
			}
			inst.exists(true);
			rsl[i] = inst;
		}
		for (int i = 0; i < n; i++) {
			rsl[i].exists(false);
		}
		return rsl;
	}
	
	public void move() {
		hasNoActor = false;
		for (int i = 0; i < actors.length; i++) {
			T a = actors[i];
			if (a.exists())
				a.move();
		}
	}
	
	public void draw(GL gl) {
		for (int i = 0; i < actors.length; i++) {
			T a = actors[i];
			if (a.exists())
				a.draw(gl);
		}
	}
	
	public void clear() {
		for (int i = 0; i < actors.length; i++) {
			T a = actors[i];
			a.exists(false);
		}
		actorIdx = 0;
	}
}