package abagames.util.sdl;

import javax.media.opengl.GL;

//private import opengl;
//private import abagames.util.sdl.sdlexception;

/**
 * Display list of OpenGL.
 */
public class DisplayList {
	private boolean registered;
	private int num;
	private int idx;
	private int enumIdx;

	public DisplayList(GL gl, int num) {
		this.num = num;
		idx = gl.glGenLists(num);
	}

	public void beginNewList(GL gl) {
		resetList();
		newList(gl);
	}

	public void nextNewList(GL gl) {
		gl.glEndList();
		enumIdx++;
		if (enumIdx >= idx + num || enumIdx < idx)
			throw new SDLException("Can't create new list. Index out of bound.");
		gl.glNewList(enumIdx, GL.GL_COMPILE);
	}
	
	public void endNewList(GL gl) {
		gl.glEndList();
		registered = true;
	}

	public void resetList() {
		enumIdx = idx;
	}

	public void newList(GL gl) {
		gl.glNewList(enumIdx, GL.GL_COMPILE);
	}

	public void endList(GL gl) {
		gl.glEndList();
		enumIdx++;
		registered = true;
	}

	public void call(GL gl) {
		call(gl, 0);
	}
	
	public void call(GL gl, int i) {
		gl.glCallList(idx + i);
	}

	public void close(GL gl) {
		if (!registered)
			return;
		gl.glDeleteLists(idx, num);
	}
}
