/*
 * $Id: frame.d,v 1.1.1.1 2006/11/19 07:54:55 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.util.sdl;

import javax.media.opengl.GL;

import abagames.util.*;

//private import abagames.util.preference;
//private import abagames.util.sdl.mainloop;
//private import abagames.util.sdl.screen;
//private import abagames.util.sdl.input;

/**
 * Lifecycle of the game.
 */
abstract public class Frame {
	protected MainLoop mainLoop;
	protected Screen abstractScreen;
	protected Input abstractInput;
	protected Preference abstractPreference;

	public void setMainLoop(MainLoop mainLoop) {
		this.mainLoop = mainLoop;
	}

	public void setUIs(Screen screen, Input input) {
		abstractScreen = screen;
		abstractInput = input;
	}

	public void setPreference(Preference preference) {
		abstractPreference = preference;
	}

	public abstract void init(GL gl);
	public abstract void start(GL gl);
	public abstract void quit(GL gl);
	public abstract void move(GL gl);
	public abstract void draw(GL gl);
}
