/*
 * $Id: recordableinput.d,v 1.1.1.1 2006/11/19 07:54:55 kenta Exp $
 *
 * Copyright 2005 Kenta Cho. Some rights reserved.
 */
package abagames.util.sdl;

import java.io.DataInputStream;
import java.io.DataOutputStream;

//private import std.stream;
//private import abagames.util.iterator;

/**
 * Record an input for a replay.
 * T represents a data structure of a specific device input.
 */
public class RecordableInput<T extends Recordable> {
	public InputRecord<T> inputRecord;
	T org;
	public RecordableInput(T o) {
		org = o;
	}
	public void startRecord() {
		inputRecord = new InputRecord<T>(org);
		inputRecord.clear();
	}

	public void record(T d) {
		inputRecord.add(d);
	}

	public void startReplay(InputRecord<T> pr) {
		inputRecord = pr;
		inputRecord.reset();
	}

	public T replay() {
		if (!inputRecord.hasNext())
			throw new NoRecordDataException("No record data.");
		return inputRecord.next();
	}
}
class InputRecordData<T> {
	public void set(T t) {

	}
	public T get() {
		return null;
	}
}
interface Recordable {
	public void write(DataOutputStream os);
	public void read(DataInputStream is);
	public Recordable clone();
	public void set(Recordable r);
}
