package sdl;

/* Include file for SDL event handling */

//import SDL_types;
//import SDL_active;
//import SDL_keyboard;
//import SDL_mouse;
//import SDL_joystick;
//import SDL_syswm;

//extern(C):


/* General event structure */
public class SDL_Event {
	public EventType type;
//	SDL_ActiveEvent active;
//	SDL_KeyboardEvent key;
//	SDL_MouseMotionEvent motion;
//	SDL_MouseButtonEvent button;
//	SDL_JoyAxisEvent jaxis;
//	SDL_JoyBallEvent jball;
//	SDL_JoyHatEvent jhat;
//	SDL_JoyButtonEvent jbutton;
//	SDL_ResizeEvent resize;
//	SDL_ExposeEvent expose;
//	SDL_QuitEvent quit;
//	SDL_UserEvent user;
//	SDL_SysWMEvent syswm;
//	
	/* Event enumerations */

	public static enum EventType {
		SDL_NOEVENT,			/* Unused (do not remove) */
		SDL_ACTIVEEVENT,			/* Application loses/gains visibility */
		SDL_KEYDOWN,			/* Keys pressed */
		SDL_KEYUP,			/* Keys released */
		SDL_MOUSEMOTION,			/* Mouse moved */
		SDL_MOUSEBUTTONDOWN,		/* Mouse button pressed */
		SDL_MOUSEBUTTONUP,		/* Mouse button released */
		SDL_JOYAXISMOTION,		/* Joystick axis motion */
		SDL_JOYBALLMOTION,		/* Joystick trackball motion */
		SDL_JOYHATMOTION,		/* Joystick hat position change */
		SDL_JOYBUTTONDOWN,		/* Joystick button pressed */
		SDL_JOYBUTTONUP,			/* Joystick button released */
		SDL_QUIT,			/* User-requested quit */
		SDL_SYSWMEVENT,			/* System specific event */
		SDL_EVENT_RESERVEDA,		/* Reserved for future use.. */
		SDL_EVENT_RESERVEDB,		/* Reserved for future use.. */
		SDL_VIDEORESIZE,			/* User resized video mode */
		SDL_VIDEOEXPOSE,			/* Screen needs to be redrawn */
		SDL_EVENT_RESERVED2,		/* Reserved for future use.. */
		SDL_EVENT_RESERVED3,		/* Reserved for future use.. */
		SDL_EVENT_RESERVED4,		/* Reserved for future use.. */
		SDL_EVENT_RESERVED5,		/* Reserved for future use.. */
		SDL_EVENT_RESERVED6,		/* Reserved for future use.. */
		SDL_EVENT_RESERVED7,		/* Reserved for future use.. */
	}
//	/* Events SDL_USEREVENT through SDL_MAXEVENTS-1 are for your use */
//	public static final int SDL_USEREVENT = 24;
//	/* This last event is only for bounding internal arrays
//	 It is the number of bits in the event mask datatype -- Uint32
//	 */
//	public static final int SDL_NUMEVENTS = 32;
//
//	/* Predefined event masks */
//	int SDL_EVENTMASK(int X) { return 1 << (X); }
//
//	public static final int SDL_ACTIVEEVENTMASK	= 1 << SDL_ACTIVEEVENT;
//	public static final int SDL_KEYDOWNMASK		= 1 << SDL_KEYDOWN;
//	public static final int SDL_KEYUPMASK		= 1 << SDL_KEYUP;
//	public static final int SDL_MOUSEMOTIONMASK	= 1 << SDL_MOUSEMOTION;
//	public static final int SDL_MOUSEBUTTONDOWNMASK	= 1 << SDL_MOUSEBUTTONDOWN;
//	public static final int SDL_MOUSEBUTTONUPMASK	= 1 << SDL_MOUSEBUTTONUP;
//	public static final int SDL_MOUSEEVENTMASK	= (1 << SDL_MOUSEMOTION) |
//	                          (1 << SDL_MOUSEBUTTONDOWN)|
//	                          (1 << SDL_MOUSEBUTTONUP);
//	public static final int SDL_JOYAXISMOTIONMASK	= (1 << SDL_JOYAXISMOTION);
//	public static final int SDL_JOYBALLMOTIONMASK	= (1 << SDL_JOYBALLMOTION);
//	public static final int SDL_JOYHATMOTIONMASK	= (1 << SDL_JOYHATMOTION);
//	public static final int SDL_JOYBUTTONDOWNMASK	= (1 << SDL_JOYBUTTONDOWN);
//	public static final int SDL_JOYBUTTONUPMASK	= 1 << SDL_JOYBUTTONUP;
//	public static final int SDL_JOYEVENTMASK	= (1 << SDL_JOYAXISMOTION)|
//	                          (1 << SDL_JOYBALLMOTION)|
//	                          (1 << SDL_JOYHATMOTION)|
//	                          (1 << SDL_JOYBUTTONDOWN)|
//	                          (1 << SDL_JOYBUTTONUP);
//	public static final int SDL_VIDEORESIZEMASK	= 1 << SDL_VIDEORESIZE;
//	public static final int SDL_VIDEOEXPOSEMASK	= 1 << SDL_VIDEOEXPOSE;
//	public static final int SDL_QUITMASK		= 1 << SDL_QUIT;
//	public static final int SDL_SYSWMEVENTMASK	= 1 << SDL_SYSWMEVENT;
//
//	public static final int SDL_ALLEVENTS	= 0xFFFFFFFF;
//
//	/* Application visibility event structure */
//	public static class SDL_ActiveEvent {
//		int type;	/* SDL_ACTIVEEVENT */
//		int gain;	/* Whether given states were gained or lost (1/0) */
//		int state;	/* A mask of the focus states */
//	}
//
//	/* Keyboard event structure */
//	public static class SDL_KeyboardEvent {
//		int type;	/* SDL_KEYDOWN or SDL_KEYUP */
//		int which;	/* The keyboard device index */
//		int state;	/* SDL_PRESSED or SDL_RELEASED */
//		SDL_keysym keysym;
//	}
//
//	/* Mouse motion event structure */
//	public static class SDL_MouseMotionEvent {
//		int type;	/* SDL_MOUSEMOTION */
//		int which;	/* The mouse device index */
//		int state;	/* The current button state */
//		int x, y;	/* The X/Y coordinates of the mouse */
//		int xrel;	/* The relative motion in the X direction */
//		int yrel;	/* The relative motion in the Y direction */
//	}
//	
//	/* Mouse button event structure */
//	public static class SDL_MouseButtonEvent {
//		int type;	/* SDL_MOUSEBUTTONDOWN or SDL_MOUSEBUTTONUP */
//		int which;	/* The mouse device index */
//		int button;	/* The mouse button index */
//		int state;	/* SDL_PRESSED or SDL_RELEASED */
//		int x, y;	/* The X/Y coordinates of the mouse at press time */
//	}
//
//	/* Joystick axis motion event structure */
//	public static class SDL_JoyAxisEvent {
//		int type;	/* SDL_JOYAXISMOTION */
//		int which;	/* The joystick device index */
//		int axis;	/* The joystick axis index */
//		int value;	/* The axis value (range: -32768 to 32767) */
//	}
//	
//	/* Joystick trackball motion event structure */
//	public static class SDL_JoyBallEvent {
//		int type;	/* SDL_JOYBALLMOTION */
//		int which;	/* The joystick device index */
//		int ball;	/* The joystick trackball index */
//		int xrel;	/* The relative motion in the X direction */
//		int yrel;	/* The relative motion in the Y direction */
//	}
//
//	/* Joystick hat position change event structure */
//	public static class SDL_JoyHatEvent {
//		int type;	/* SDL_JOYHATMOTION */
//		int which;	/* The joystick device index */
//		int hat;	/* The joystick hat index */
//		int value;	/* The hat position value:
//		8   1   2
//		7   0   3
//		6   5   4
//		Note that zero means the POV is centered.
//		*/
//	}
//
//	/* Joystick button event structure */
//	public static class SDL_JoyButtonEvent {
//		int type;	/* SDL_JOYBUTTONDOWN or SDL_JOYBUTTONUP */
//		int which;	/* The joystick device index */
//		int button;	/* The joystick button index */
//		int state;	/* SDL_PRESSED or SDL_RELEASED */
//	}
//
//	/* The "window resized" event
//	 When you get this event, you are responsible for setting a new video
//	 mode with the new width and height.
//	 */
//	public static class SDL_ResizeEvent {
//		int type;	/* SDL_VIDEORESIZE */
//		int w;		/* New width */
//		int h;		/* New height */
//	}
//
//	/* The "screen redraw" event */
//	public static class SDL_ExposeEvent {
//		int type;	/* SDL_VIDEOEXPOSE */
//	}
//
//	/* The "quit requested" event */
//	public static class SDL_QuitEvent {
//		int type;	/* SDL_QUIT */
//	}
//	
//	/* A user-defined event type */
//	public static class SDL_UserEvent {
//		int type;	/* SDL_USEREVENT through SDL_NUMEVENTS-1 */
//		int code;	/* User defined event code */
//		Object data1;	/* User defined data pointer */
//		Object data2;	/* User defined data pointer */
//	}
//
//	/* If you want to use this event, you should include SDL_syswm.h */
//	public static class SDL_SysWMEvent {
//		int type;
//		SDL_SysWMmsg msg;
//	}
//
//	/* Function prototypes */
//
//	/* Pumps the event loop, gathering events from the input devices.
//	 This function updates the event queue and internal input device state.
//	 This should only be run in the thread that sets the video mode.
//	 */
//	public void SDL_PumpEvents() {
//	}
//	
//	/* Checks the event queue for messages and optionally returns them.
//	 If 'action' is SDL_ADDEVENT, up to 'numevents' events will be added to
//	 the back of the event queue.
//	 If 'action' is SDL_PEEKEVENT, up to 'numevents' events at the front
//	 of the event queue, matching 'mask', will be returned and will not
//	 be removed from the queue.
//	 If 'action' is SDL_GETEVENT, up to 'numevents' events at the front 
//	 of the event queue, matching 'mask', will be returned and will be
//	 removed from the queue.
//	 This function returns the number of events actually stored, or -1
//	 if there was an error.  This function is thread-safe.
//	 */
//	//	alias int SDL_eventaction;
//	//enum {
//	public static final int SDL_ADDEVENT = 0;
//	public static final int SDL_PEEKEVENT = 1;
//	public static final int SDL_GETEVEN = 2;
//	/* */
//	public int SDL_PeepEvents(SDL_Event events, int numevents,
//			SDL_eventaction action, int mask) {
//		return 0;
//	}
//	
//	/* Polls for currently pending events, and returns 1 if there are any pending
//	 events, or 0 if there are none available.  If 'event' is not NULL, the next
//	 event is removed from the queue and stored in that area.
//	 */
//	public int SDL_PollEvent(SDL_Event event) {
//		return 0;
//	}
//
//	/* Waits indefinitely for the next available event, returning 1, or 0 if there
//	 was an error while waiting for events.  If 'event' is not NULL, the next
//	 event is removed from the queue and stored in that area.
//	 */
//	public int SDL_WaitEvent(SDL_Event event) {
//		return 0;
//	}
//
//	/* Add an event to the event queue.
//	 This function returns 0, or -1 if the event couldn't be added to
//	 the event queue.  If the event queue is full, this function fails.
//	 */
//	public int SDL_PushEvent(SDL_Event event) {
//		return 0;
//	}
//
//	/*
//	 This function sets up a filter to process all events before they
//	 change internal state and are posted to the internal event queue.
//	 
//	 The filter is protypted as:
//	 */
////	alias int (*SDL_EventFilter)(SDL_Event *event);
//	/*
//	 If the filter returns 1, then the event will be added to the internal queue.
//	 If it returns 0, then the event will be dropped from the queue, but the 
//	 internal state will still be updated.  This allows selective filtering of
//	 dynamically arriving events.
//	 
//	 WARNING:  Be very careful of what you do in the event filter function, as 
//	 it may run in a different thread!
//	 
//	 There is one caveat when dealing with the SDL_QUITEVENT event type.  The
//	 event filter is only called when the window manager desires to close the
//	 application window.  If the event filter returns 1, then the window will
//	 be closed, otherwise the window will remain open if possible.
//	 If the quit event is generated by an interrupt signal, it will bypass the
//	 internal queue and be delivered to the application at the next event poll.
//	 */
//	public void SDL_SetEventFilter(SDL_EventFilter filter) {
//	}
//
//	/*
//	 Return the current event filter - can be used to "chain" filters.
//	 If there is no event filter set, this function returns NULL.
//	 */
//	public SDL_EventFilter SDL_GetEventFilter() {
//		return null;
//	}
//
//	/*
//	 This function allows you to set the state of processing certain events.
//	 If 'state' is set to SDL_IGNORE, that event will be automatically dropped
//	 from the event queue and will not event be filtered.
//	 If 'state' is set to SDL_ENABLE, that event will be processed normally.
//	 If 'state' is set to SDL_QUERY, SDL_EventState() will return the 
//	 current processing state of the specified event.
//	 */
//	public static final int SDL_QUERY	= -1;
//	public static final int SDL_IGNORE	= 0;
//	public static final int SDL_DISABLE	= 0;
//	public static final int SDL_ENABLE	= 1;
//	public int SDL_EventState(int type, int state) {
//		return 0;
//	}
//	
}